import swarm.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.space.*;
import swarm.collections.*;

public class ModelSwarm extends SwarmImpl{	
	public int N; // N: S̐
	public double male_femaleRatio; // male_femaleRatio: Y(S̐ɑ΂Y̂̊)
	public double tGeneRatio; // tGeneRatio: S̐ɑ΂T1`q̂̊
	public double pGeneRatio; // pGeneRatio: S̐ɑ΂P1`q̂̊
	
	public double a0Coeff, a1Coeff; // a0Coeff, a1Coeff: Kirkpatrick̃f̗YIɂm̌W
	public double maleDeathProb; // Y̌zOŊm(ׂĂ̗Y̌zOŊm̃x[X)
	public double femaleDeathProb; // FemaleProb:̌zOŊm
	public double sRatio; // T`qY̌zOŊm̔DT1`qYT0`qYɔׂ(1 - sRatio){̐D
	private double tMaleDeathProb[]; // tMaleDeathProb:T`qƂ̗Y̌zOŊmD

	private double[] BreedProb; // BreedProb: YmiBreedProb[0] = P(T0|P0), BreedProb[1] = P(T1|P1)j
	private int[][][] figures; // figures: ̂̓vDfigures[ʁi0:YC1:j][T`q][P`q]

	public int time; // time: 
	public int EndTime; // EndTime: IƂȂ鐢

	public int lifetime; // lifetime: ̂̎
	public int numChild; // numChild: x̌zŐގq̐ 
	
	List[] tMaleList; // tMaleList: T`qƂ̗Y̃Xg
    List femaleList; // femaleList: ̃Xg
    
	double v1, v2; // v1, v2: Kirkpatrick̃f̕tԂł̈`qpx̊֌ŴV1, V2

	
	// ftHgRXgN^
	public ModelSwarm(Zone aZone){
		super(aZone);
//		this.aZone = aZone;
		N = 1000;
		male_femaleRatio = 0.5;
		tGeneRatio = 0.5;
		pGeneRatio = 0.5;

		maleDeathProb = 0.0;
		sRatio = 0.2;
		femaleDeathProb = 0.0;

		a0Coeff = 2.0;
		a1Coeff = 3.0;
		EndTime = 100;
		lifetime = 1;
		numChild = 2;
		
		makeProbe(aZone);
	}
	
	private void makeProbe(Zone aZone){
		EmptyProbeMap probe = new EmptyProbeMapImpl(aZone, this.getClass());
		
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("N",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("male_femaleRatio",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("tGeneRatio",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("pGeneRatio",this.getClass()));

		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("maleDeathProb",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("sRatio",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("femaleDeathProb",this.getClass()));

		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("a0Coeff",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("a1Coeff",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("EndTime",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("lifetime",this.getClass()));
		probe.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("numChild",this.getClass()));

		probe.addProbe(Globals.env.probeLibrary.getProbeForMessage$inClass("initObjects",getClass()));
		Globals.env.probeLibrary.setProbeMap$For(probe,this.getClass());
		
	}
	
	private void clearLists(){
		for(int i=0;i<2;i++){
			int count = tMaleList[i].getCount();
			for(int j=0;j<count;j++){
				Male male = (Male) tMaleList[i].removeFirst();
				male.drop();
			}
		}
		
		int count = femaleList.getCount();
		for(int i=0;i<count;i++){
			Female female = (Female) femaleList.removeFirst();
			female.drop();
		}
		
	}
	// 
	public Object buildObjects(){
		Male aMale;
		Female aFemale;

		int x, y, z;
		int tGene, pGene;

		tMaleList = new List[2];
		tMaleList[0] = new ListImpl(this);
		tMaleList[1] = new ListImpl(this);
		femaleList = new ListImpl(this);

		tMaleDeathProb = new double[2];
		tMaleDeathProb[0] = maleDeathProb;
		tMaleDeathProb[1] = (double)1 - ((1 - maleDeathProb) * (1 - sRatio));

		BreedProb = new double[2];

		time = 0;

		figures = new int[2][2][2];
		for(x = 0; x < 2; x++)
			for(y = 0; y < 2; y++)
				for(z = 0; z < 2; z++)
					figures[x][y][z] = 0;

		v1 = (a0Coeff + sRatio -1) / (a0Coeff * a1Coeff - 1) / (1 - sRatio);
		v2 = a1Coeff * (a0Coeff + sRatio -1) / (a0Coeff * a1Coeff - 1);

		// ̂̐
		for (x = 0; x < N; x++){

			// T`q
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < tGeneRatio) {
				tGene = 1;
			} else {
				tGene = 0;
			}

			// P`q
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < pGeneRatio) {
				pGene = 1;
			} else {
				pGene = 0;
			}
			
			// ʌ
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < male_femaleRatio) {
			
				// Y̂̐
				aMale = new Male(this, tGene, pGene);
				aMale.setDeathProb(tMaleDeathProb[tGene]);
				tMaleList[tGene].addLast(aMale);
				addFigures(0, tGene, pGene);

			} else {

				// ̂̐
				aFemale = new Female(this, tGene, pGene);
				aFemale.setDeathProb(femaleDeathProb);
				femaleList.addLast(aFemale);
				addFigures(1, tGene, pGene);
			}	
		}
		System.out.println("Death Probability\nT0Male: " + tMaleDeathProb[0]
								+ "\tT1Male: " + tMaleDeathProb[1]
								+ "\tFemale: " + femaleDeathProb);
		calcBreedProb();
		showRatio();
		showCount();
		time++;
		return this;
	}
	
	public void initObjects(){
		Male aMale;
		Female aFemale;

		int x, y, z;
		int tGene, pGene;

		clearLists();
		tMaleDeathProb[0] = maleDeathProb;
		tMaleDeathProb[1] = (double)1 - ((1 - maleDeathProb) * (1 - sRatio));
		time = 0;
		
		for(x = 0; x < 2; x++)
			for(y = 0; y < 2; y++)
				for(z = 0; z < 2; z++)
					figures[x][y][z] = 0;

		v1 = (a0Coeff + sRatio -1) / (a0Coeff * a1Coeff - 1) / (1 - sRatio);
		v2 = a1Coeff * (a0Coeff + sRatio -1) / (a0Coeff * a1Coeff - 1);

		// ̂̐
		for (x = 0; x < N; x++){

			// T`q
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < tGeneRatio) {
				tGene = 1;
			} else {
				tGene = 0;
			}

			// P`q
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < pGeneRatio) {
				pGene = 1;
			} else {
				pGene = 0;
			}
			
			// ʌ
			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < male_femaleRatio) {
			
				// Y̂̐
				aMale = new Male(this, tGene, pGene);
				aMale.setDeathProb(tMaleDeathProb[tGene]);
				tMaleList[tGene].addLast(aMale);
				addFigures(0, tGene, pGene);

			} else {

				// ̂̐
				aFemale = new Female(this, tGene, pGene);
				aFemale.setDeathProb(femaleDeathProb);
				femaleList.addLast(aFemale);
				addFigures(1, tGene, pGene);
			}	
		}
		System.out.println("Death Probability\nT0Male: " + tMaleDeathProb[0]
								+ "\tT1Male: " + tMaleDeathProb[1]
								+ "\tFemale: " + femaleDeathProb);
		calcBreedProb();
		showRatio();
		showCount();
		time++;
	}
	
	// T`qY̂̑Ԃ
	public int countTMale(int tGene){
		return tMaleList[tGene].getCount();
	}

	// ̂̑Ԃ
	public int countFemale(){
		return femaleList.getCount();
	}


	// T0`q̌̐Ԃ
	public int countT0Gene() {
		int x, y;
		int numT = 0;

		for(x = 0; x <= 1; x++)
			for(y = 0; y <= 1; y++)
				numT += figures[x][0][y];

		if(numT < 0) {
			System.out.println("T0MaleCount:" + countTMale(0) + "\tT1MaleCount:" + countTMale(1) + "\tFemaleCount: " + countFemale());
		}

		return numT;
	}

	// T1`q̌̐Ԃ
	public int countT1Gene() {
		int x, y;
		int numT = 0;

		for(x = 0; x <= 1; x++)
			for(y = 0; y <= 1; y++)
				numT += figures[x][1][y];

		return numT;
	}

	// P0`q̌̐Ԃ
	public int countP0Gene() {
		int x, y;
		int numP = 0;

		for(x = 0; x <= 1; x++)
			for(y = 0; y <= 1; y++)
				numP += figures[x][y][0];

		return numP;
	}

	// P1`q̌̐Ԃ
	public int countP1Gene() {
		int x, y;
		int numP = 0;

		for(x = 0; x <= 1; x++)
			for(y = 0; y <= 1; y++)
				numP += figures[x][y][1];

		return numP;
	}


	// ̂̑Ԃ
	public int countTotal() {
		return countTMale(0) + countTMale(1) + countFemale();
	}


	// ݂T1`q̊Ԃ
	public double getT1Ratio(){
		return (double)countT1Gene() / countTotal();
	}

	// ݂P1`q̊Ԃ
	public double getP1Ratio(){
		return (double)countP1Gene() / countTotal();
	}


	// ̐܂Ői߂邩fDi߂ꍇ͐i߂D
	public boolean checkToStop(){
		if(time >= EndTime) {
			System.out.println("Timeout");
			return false;
		} else if(countTMale(0) == 0 && countTMale(1) == 0) {
			System.out.println("Male dies out");
			return false;
		} else if(countFemale() == 0) {
			System.out.println("Female dies out");
			return false;
		} else if(countT0Gene() == 0){
			System.out.println("Gene T0 dies out");
			return false;
		} else if(countT1Gene() == 0){
			System.out.println("Gene T1 dies out");
			return false;
		} else if(countP0Gene() == 0){
			System.out.println("Gene P0 dies out");
			return false;
		} else if(countP1Gene() == 0){
			System.out.println("Gene P1 dies out");
			return false;
		}

		time++;
		return true;
	}


	// ݂T0`qCT1`qCP0`qCP1`q̌̐\
	public void showCount(){
		System.out.println("\t (T0, T1) = (" + countT0Gene() + ", " + countT1Gene() + ")\t"
			+ "(P0, P1) = (" + countP0Gene() + ", " + countP1Gene() + ")");	}

	// ݂T0`qYCT1`qYCP0`qCP1`q̌̐\
	public void showRatio(){
		System.out.println("[Generation:" + time + "] T1: " + getT1Ratio() + "\tP1: " + getP1Ratio());
	}

	// YmvZ
	private void calcBreedProb(){
		int t0Male = tMaleList[0].getCount(),
			t1Male = tMaleList[1].getCount();

		BreedProb[0] = (a0Coeff * t0Male) / (t1Male + a0Coeff * t0Male);
		BreedProb[1] = (a1Coeff * t1Male) / (t0Male + a1Coeff * t1Male);
	}

	// z
	private void coupling() {
		Female aFemale;
		ListShuffler shuffler;
		int femaleCount;
		int x;

		// tMaleList[0], tMaleList[1], femaleListVbt
		shuffler = new ListShufflerImpl(this.getZone());
		shuffler.shuffleWholeList(tMaleList[0]);
		shuffler.shuffleWholeList(tMaleList[1]);
		shuffler.shuffleWholeList(femaleList);

		femaleCount = countFemale();
		
		for(x = 0; x < femaleCount; x++){

			// Xg̐擪̎o
			aFemale = (Female)femaleList.removeFirst();

			if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < BreedProb[aFemale.getP()]){
		
				// P0T0ƁCP1T1ƌz

				select(aFemale.getT(), aFemale.getP(), aFemale.getP());

			} else {

				// P0T1ƁCP1T0ƌz

				select(aFemale.getT(), aFemale.getP(), (aFemale.getP() + 1)%2);
			}

			// oXg̍Ōɖ߂
			femaleList.addLast(aFemale);

		}

	}

	// ɂȂYI
	private void select(int femaleT, int femaleP, int maleT){
		Male aMale;
		int maleTCount;
		int x, y;

		// ̑ƂȂT`qY̑擾
		maleTCount = countTMale(maleT);

		// ̑ƂȂT`qY݂ȂƂ͌zȂ
		if(maleTCount <= 0) return;

		for(x = 0; x < maleTCount; x++) {
			// ̗YƂ肾
			aMale = (Male)tMaleList[maleT].removeFirst();
					
			// ܂ɂȂĂȂ΁Cz
			if(!aMale.married) {
				aMale.married = true;
				for(y = 0; y < numChild; y++){
					breed(aMale.getT(), aMale.getP(), femaleT, femaleP);
				}
				// Ƃ肾YXg̍Ōɖ߂
				tMaleList[maleT].addLast(aMale);
				break;
			}
			// Ƃ肾YXg̍Ōɖ߂
			tMaleList[maleT].addLast(aMale);
		}
				
	}

	// ̐̎q𐶐Ce̃Xgɒǉ
	private void breed(int maleT, int maleP, int femaleT, int femaleP){
		int tGene, pGene;
		Male aMale;
		Female aFemale;

		// qT`q
		if(maleT == femaleT) {
			tGene = maleT;
		} else {
			if(Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < 0.5)
				tGene = maleT;
			else
				tGene = femaleT;		
		}

		// qP`q
		if(maleP == femaleP) {
			pGene = maleP;
		} else {
			if(Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < 0.5)
				pGene = maleP;
			else
				pGene = femaleP;		
		}
		
		// ʂ̌
		if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < 0.5){
			
			// Y𐶐
			aMale = new Male(this, tGene, pGene);
			aMale.setDeathProb(tMaleDeathProb[tGene]);
			tMaleList[tGene].addLast(aMale);
			addFigures(0, tGene, pGene);

		} else {

			// 𐶐
			aFemale = new Female(this, tGene, pGene);
			aFemale.setDeathProb(femaleDeathProb);
			femaleList.addLast(aFemale);
			addFigures(1, tGene, pGene);
		}
	}

	// vfiguresɐVȌ̂̃f[^𔽉f
	private void addFigures(int sex, int tGene, int pGene){
		figures[sex][tGene][pGene]++;
	}

	// vfiguresɌ̂̎S𔽉f
	private void removeFigures(int sex, int tGene, int pGene){
		figures[sex][tGene][pGene]--;
	}

	// mŌ̂SƂƂɎɂȂ̂S
	private void die(){
		Male aMale;
		Female aFemale;
		int count;
		int x, y;

		// Y̐
		for(x = 0; x < 2; x++) {

			// Tx`qY̑擾
			count = countTMale(x);

			for(y = 0; y < count; y++) {
				// Xg̐擪Ƃ肾
				aMale = (Male)tMaleList[x].removeFirst();

				if(aMale.getAge() >= lifetime || Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < tMaleDeathProb[x]){
					// S
					removeFigures(0, x, aMale.getP());
					aMale.drop(); // add by yanase to free memory.
				} else {
					// Ƃ肾̂EXg̍Ōɖ߂
					tMaleList[x].addLast(aMale);
				}
			}
		}

		// ̐

		// ̑擾
		count = countFemale();

		for(x = 0; x < count; x++) {
			// Xg̐擪Ƃ肾
			aFemale = (Female)femaleList.removeFirst();

			if(aFemale.getAge() >= lifetime || Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < femaleDeathProb){
				// S
				removeFigures(1, aFemale.getT(), aFemale.getP());
				aFemale.drop(); // add by yanase to free memory
			} else {
				// Ƃ肾̂EXg̍Ōɖ߂
				femaleList.addLast(aFemale);
			}
		}
	}


	// N1₵CYmarriedfalseɂD
	private void nextAge(){
		Male aMale;
		Female aFemale;
		int count;
		int x, y;

		// Y
		for(x = 0; x < 2; x++) {

			// Tx`qY̑擾
			count = countTMale(x);

			for(y = 0; y < count; y++) {
				aMale = (Male)tMaleList[x].removeFirst();
				aMale.age();
				tMaleList[x].addLast(aMale);
			}
		}

		// 

		// Tx`qY̑擾
		count = countFemale();

		for(x = 0; x < count; x++) {
			aFemale = (Female)femaleList.removeFirst();
			aFemale.age();
			femaleList.addLast(aFemale);
		}
	}

	// Kirkpatrick̃fɂ镽tԂT1`qpxԂ
	public double getEquilibriumValue(){
		double tmp, p1Ratio;
		p1Ratio = getP1Ratio();

		tmp = 1 - sRatio;

		if(p1Ratio <= v1) {
			return 0;
		} else if (p1Ratio < v2) {
			return ( (a0Coeff * a1Coeff - 1) * tmp / (a0Coeff - tmp) * p1Ratio - 1 ) / (a1Coeff * tmp - 1) ;
		} else {
			return 1;
		}
	}

	// eł̏
	public void step() {
		/*
		if(isfirst){
			isfirst = false;
			initObjects();
		}
		*/
		
		// `qƂ̎ŶmvZ
		calcBreedProb();

		
		// N1₵CYmarriedfalseɂ
		nextAge();

		// z
		coupling();

		// mŌ̂SƂƂɎɂȂ̂S
		die();

		// ݂̏󋵂\
		showRatio();
		showCount();
	}
}
